package com.eactive.eai.rms.bap.manage.work.bizgbn;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import com.eactive.eai.rms.common.base.BapBaseAnnotationController;
import com.eactive.eai.rms.common.combo.ComboService;
import com.eactive.eai.rms.common.util.CamelCaseUtil;
import com.eactive.eai.rms.common.vo.JsonPageVo;
import com.google.gson.Gson;

@Controller
public class BapBizGbnController extends BapBaseAnnotationController {

	@Autowired
	@Qualifier("bapBizGbnService")
	private BapBizGbnService service;

    @Autowired
    private ComboService comboService;

	@RequestMapping(value= "/bap/admin/work/bizGbnMan.view")
	public String viewList(HttpServletRequest request, @RequestParam(value = "cmd", required = false ) String cmd ) throws Exception {
		if (cmd == null || "LIST".equals(cmd.toUpperCase())) {
			cmd = "";
		} else {
			cmd = CamelCaseUtil.converCamelCase(cmd);
		}
		String path = request.getServletPath();
		return path.split("[.]")[0]+cmd;
	}
	
	/**
	 * @param request
	 * @param response
	 * @throws Exception
	 */
	@RequestMapping(value= "/bap/admin/work/bizGbnMan.json", params = "cmd=LIST")
	public ModelAndView selectList(HttpServletRequest request,
			JsonPageVo pageVo , @RequestParam HashMap<String, Object> paramMap) throws Exception {
		
		HashMap<String, Object> map = service.selectList( pageVo.getStartNum(), pageVo.getEndNum(), paramMap);
		
		pageVo.setTotalCount((Integer)map.get("totalCount"));
		
		Map<String, Object> resultMap = new HashMap<String, Object>();
		resultMap.put("total"  , pageVo.getTotal());  //전체 페이지수
		resultMap.put("page"   , pageVo.getPage());   //현재 페이지수
		resultMap.put("records", pageVo.getTotalCount());//전체 레코드건수
		resultMap.put("rows"   , map.get("list"));

		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);
		return modelAndView;
	}

	@RequestMapping(value= "/bap/admin/work/bizGbnMan.json", params = "cmd=DETAIL")
	public ModelAndView selectDetail(HttpServletRequest request,
			HttpServletResponse response, String bjobBzwkDstcd) throws Exception {
		
		HashMap<String, Object> map = service.selectDetail(bjobBzwkDstcd);

		ModelAndView modelAndView = new ModelAndView("jsonView", map);	
		
		return modelAndView;
	}

	@RequestMapping(value= "/bap/admin/work/bizGbnMan.json", params = "cmd=INSERT")
	public String insert(HttpServletRequest request,
			HttpServletResponse response,@RequestParam HashMap<String,Object> map, String gridData ) throws Exception {
    	Gson gson = new Gson();
    	@SuppressWarnings("unchecked")
		HashMap<String, Object>[] list = gson.fromJson(gridData, HashMap[].class);
		String userid = com.eactive.eai.rms.common.login.SessionManager.getUserId(request);
		map.put("userid", userid );
    	service.insert(map,list);
		return null;
	}

	@RequestMapping(value= "/bap/admin/work/bizGbnMan.json", params = "cmd=UPDATE")
	public String update(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> paramMap, String gridData ) throws Exception {

    	Gson gson = new Gson();
    	@SuppressWarnings("unchecked")
		HashMap<String, Object>[] list = gson.fromJson(gridData, HashMap[].class);
		String userid = com.eactive.eai.rms.common.login.SessionManager.getUserId(request);
		paramMap.put("userid", userid );
		service.update(paramMap, list);

		return null;
	}

	@RequestMapping(value= "/bap/admin/work/bizGbnMan.json", params = "cmd=DELETE")
	public String delete(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String, Object> paramMap ) throws Exception {
		service.delete(paramMap);
		return null;
	}

	@RequestMapping(value= "/bap/admin/work/bizGbnMan.json", params = "cmd=LIST_INIT_COMBO")
    public ModelAndView initGroupCoCdCombo( HttpServletRequest request,
            HttpServletResponse response) throws Exception {
    	
//		List<Map<String, Object>> groupCoCd     = comboService.selectListCombo("EAIGROUPCOCD");
        
		Map<String, Object> resultMap = new HashMap<String, Object>();
//		resultMap.put("groupCoCd"         , groupCoCd);
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);
		return modelAndView;
    }

	@RequestMapping(value= "/bap/admin/work/bizGbnMan.json", params = "cmd=LIST_BJOB_BZWK_COMBO")
    public ModelAndView initBjobBzwkDstcdCombo( HttpServletRequest request,
            HttpServletResponse response) throws Exception {
    	
//		List<Map<String, Object>> bjobBzwkDstcd     = comboService.selectListComboForTableWithCode("TSEAIBJ02", "BJOBBZWKDSTCD", "BJOBBZWKNAME");

		Map<String, Object> resultMap = new HashMap<String, Object>();
//		resultMap.put("bjobBzwkDstcd"         , bjobBzwkDstcd);
		
		ModelAndView modelAndView = new ModelAndView("jsonView",resultMap);
		return modelAndView;
    }
	
	@RequestMapping(value= "/bap/admin/work/bizGbnMan.json", params = "cmd=CLONE")
	private String clone(HttpServletRequest request,
			HttpServletResponse response, @RequestParam HashMap<String,Object> paramMap) throws Exception {
		
	 	@SuppressWarnings("unchecked")
		String userid = com.eactive.eai.rms.common.login.SessionManager.getUserId(request);
		paramMap.put("userid", userid );
		service.insertClone(paramMap);

		return null;
	}
}